/* *********************** */
/* Fitxer sonar_colbert.c  */	
/* *********************** */

#include "saphira.h"
#include "sonar.h"

/* ***************************************** */
/* Fitxers de crrega i descrrega de la dll */
/* ***************************************** */

EXPORT void
sfLoadInit(void)	// Fitxer que s'avalua al carregar-se la dll
{
	// Missatge Inici

	sfSMessage("DLL del Sonar iniciant crrega...");

	// Inicialitzaci dels valors del buffer

	sfSMessage("Inicialitzant buffers...");

	sfSetSideBuffer(40);
	sfSetFrontBuffer(20);

	// Crrega de funcions

	sfSMessage("Inicialitzant funcions...");

	sfSMessage("Inicialitzant s_actualitzar_x...");

	sfAddEvalFn("s_actualitzar",s_actualitzar,sfVOID,0,sfVOID);
	sfAddEvalFn("s_actualitzar_d",s_actualitzar_d,sfVOID,0,sfVOID);
	sfAddEvalFn("s_actualitzar_e",s_actualitzar_e,sfVOID,0,sfVOID);
	sfAddEvalFn("s_actualitzar_f",s_actualitzar_f,sfVOID,0,sfVOID);

	sfSMessage("Inicialitzant s_maxim_x...");

	sfAddEvalFn("s_maxim",s_maxim,sfINT,0,sfVOID);
	sfAddEvalFn("s_maxim_d",s_maxim_d,sfINT,0,sfVOID);
	sfAddEvalFn("s_maxim_e",s_maxim_e,sfINT,0,sfVOID);
	sfAddEvalFn("s_maxim_f",s_maxim_f,sfINT,0,sfVOID);

	sfSMessage("Inicialitzant s_posar_maxim_x...");

	sfAddEvalFn("s_posar_maxim_l",s_posar_maxim_l,sfVOID,1,sfINT);
	sfAddEvalFn("s_posar_maxim_f",s_posar_maxim_f,sfVOID,1,sfINT);

	sfSMessage("Inicialitzant s_elements_x...");

	sfAddEvalFn("s_elements",s_elements,sfINT,0,sfVOID);
	sfAddEvalFn("s_elements_d",s_elements_d,sfINT,0,sfVOID);
	sfAddEvalFn("s_elements_e",s_elements_e,sfINT,0,sfVOID);
	sfAddEvalFn("s_elements_f",s_elements_f,sfINT,0,sfVOID);

	sfSMessage("Inicialitzant s_x_x, s_y_x...");

	sfAddEvalFn("s_x",s_x,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_y",s_y,sfFLOAT,1,sfINT);

	sfAddEvalFn("s_x_d",s_x_d,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_y_d",s_y_d,sfFLOAT,1,sfINT);

	sfAddEvalFn("s_x_e",s_x_e,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_y_e",s_y_e,sfFLOAT,1,sfINT);

	sfAddEvalFn("s_x_f",s_x_f,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_y_f",s_y_f,sfFLOAT,1,sfINT);

	sfSMessage("Inicialitzant s_dist_x...");

	sfAddEvalFn("s_dist",s_dist,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_dist_d",s_dist_d,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_dist_e",s_dist_e,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_dist_f",s_dist_f,sfFLOAT,1,sfINT);

	sfSMessage("Inicialitzant angle_x...");

	sfAddEvalFn("s_angle",s_angle,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_angle_d",s_angle_d,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_angle_e",s_angle_e,sfFLOAT,1,sfINT);
	sfAddEvalFn("s_angle_f",s_angle_f,sfFLOAT,1,sfINT);

	sfSMessage("Inicialitzant s_total_quadre_x...");

	sfAddEvalFn("s_total_quadre",s_total_quadre,sfINT,
			4,sfFLOAT,sfFLOAT,sfFLOAT,sfFLOAT);
	sfAddEvalFn("s_total_quadre_d",s_total_quadre_d,sfINT,
			4,sfFLOAT,sfFLOAT,sfFLOAT,sfFLOAT);
	sfAddEvalFn("s_total_quadre_e",s_total_quadre_e,sfINT,
			4,sfFLOAT,sfFLOAT,sfFLOAT,sfFLOAT);
	sfAddEvalFn("s_total_quadre_f",s_total_quadre_f,sfINT,
			4,sfFLOAT,sfFLOAT,sfFLOAT,sfFLOAT);

	sfSMessage("Inicialitzant s_dist_min_x...");

	sfAddEvalFn("s_dist_min",s_dist_min,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_min_d",s_dist_min_d,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_min_e",s_dist_min_e,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_min_f",s_dist_min_f,sfINT,0,sfVOID);

	sfSMessage("Inicialitzant s_dist_max_x...");

	sfAddEvalFn("s_dist_max",s_dist_max,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_max_d",s_dist_max_d,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_max_e",s_dist_max_e,sfINT,0,sfVOID);
	sfAddEvalFn("s_dist_max_f",s_dist_max_f,sfINT,0,sfVOID);

	sfSMessage("Inicialitzant s_total_cercle_x...");

	sfAddEvalFn("s_total_cercle",s_total_cercle,sfINT,1,sfFLOAT);
	sfAddEvalFn("s_total_cercle_d",s_total_cercle_d,sfINT,1,sfFLOAT);
	sfAddEvalFn("s_total_cercle_e",s_total_cercle_e,sfINT,1,sfFLOAT);
	sfAddEvalFn("s_total_cercle_f",s_total_cercle_f,sfINT,1,sfFLOAT);

	// Missatge Final

	sfSMessage("DLL del Sonar carregada.");
}

EXPORT void
sfLoadExit(void)	// Fitxer que s'avalua al descarregar-se la dll
{
	sfSMessage("DLL del Sonar Descarregada.");
}
