//Starting Behavior/Act Schema Parser 
float angle_entrada;

//Defining behavior sfTurnToPosition


 /* for reference pointers */

static int _sfleft = TURN_LEFT; 
static int _sfright = TURN_RIGHT; 
static int _sfbackward = DECEL; 
static int _sfforward = ACCEL; 
static int _sfspeed = ASPEED; 




/* Starting code for behavior sfTurnToPosition  */


void sfTurnToPosition_update();
void sfTurnToPosition_setup();

/* global vars for update fn */
static float aen;
static float mod__0;
static float aeng;
static float mod__1;
static float aep;
static float mod__2;
static float aepg;
static float mod__3;

behavior
_beh_sfTurnToPosition = {"sfTurnToPosition",
    sfTurnToPosition_setup, /* setup function */
    sfTurnToPosition_update, /* body function */
    0, /* number of params */
    {sfINT},
    4, /* number of rules */
    {{"rule__0", &aen, &_sfright, &mod__0},
     {"rule__1", &aeng, &_sfright, &mod__1},
     {"rule__2", &aep, &_sfleft, &mod__2},
     {"rule__3", &aepg, &_sfleft, &mod__3}
    }
};
behavior *sfTurnToPosition = &_beh_sfTurnToPosition;



void
sfTurnToPosition_setup (beh_params _params) { 
}

/* global vars for update fn */
static float dist_zero;
static float aez;



void
sfTurnToPosition_update(beh_params _params)
{

		angle_entrada = llAnglePunt(punts,1);
		dist_zero = f_eq(llDistanciaPunt(punts,0),0.0,p_dist_tol*3);
	
		aeng = straight_down(angle_entrada,-90.0,-60.0);
		aen = straight_down(angle_entrada,-15.0,-5.0);
		aez = f_eq(angle_entrada,0.0,5.0);
		aep = up_straight(angle_entrada,5.0,15.0);
		aepg = up_straight(angle_entrada,60.0,90.0);
	 /* Begin activity section */
   c_act_v = c_act_t = 0.0;
    c_act_t = dist_zero;
    c_goal = f_and(aez,dist_zero);
    mod__0 = sfMODERATELY;
    mod__1 = sfSHARPLY;
    mod__2 = sfMODERATELY;
    mod__3 = sfSHARPLY;
}


/* Ending code for behavior sfTurnToPosition  */




static float at_max_speed = 400.0;
#define GP_TURN_FACTOR 6.0

//Defining behavior sfAnarAPos


/* Starting code for behavior sfAnarAPos  */


void sfAnarAPos_update();
void sfAnarAPos_setup();

/* global vars for update fn */
static float at_too_slow;
static float at_too_fast;
static float at_speed;
static float ant__4;
static float at_pos_on_left;
static float at_turn_amount;
static float ant__5;
static float at_pos_on_right;
static float ant__6;
static float at_pos_achieved;
static float speed__7 = 0.0;
static float ant__8;
static float at_angle_way_off;
static float speed__9 = 0.0;
static float ant__10;

behavior
_beh_sfAnarAPos = {"sfAnarAPos",
    sfAnarAPos_setup, /* setup function */
    sfAnarAPos_update, /* body function */
    2, /* number of params */
    {sfFLOAT, sfFLOAT},
    5, /* number of rules */
    {{"Approach_speed", &ant__4, &_sfspeed, &at_speed},
     {"Pos_on_left", &ant__5, &_sfleft, &at_turn_amount},
     {"Pos_on_right", &ant__6, &_sfright, &at_turn_amount},
     {"Pos_here", &ant__8, &_sfspeed, &speed__7},
     {"Angle_way_off", &ant__10, &_sfspeed, &speed__9}
    }
};
behavior *sfAnarAPos = &_beh_sfAnarAPos;



void
sfAnarAPos_setup (beh_params _params) { 
   float speed = _params[0].f;
   float radius = _params[1].f;
}

/* global vars for update fn */
static float ach;



void
sfAnarAPos_update(beh_params _params)
{
   float speed = _params[0].f;
   float radius = _params[1].f;

  float x, y, phi, delta;
  int lhs_clear, rhs_clear;
  float ach, left, right, bleft, bright, wayoff;
  float too_slow, too_fast;

  at_speed = MIN(speed,at_max_speed);
  too_fast = f_greater(sfTargetVel(),speed,(float)(speed*.2));
  too_slow = f_smaller(sfTargetVel(),at_speed,(float)(at_speed*.2));

  x = llObtenirXPunt(punts,0);
  y = llObtenirYPunt(punts,0);
  phi = llAnglePunt(punts,0);

  delta = sfTargetHead();
  if (phi < 0.0)
    {
      if (delta > phi) delta = delta - phi;
      else delta = 0.0;
    }
  else
    {
      if (delta < phi) delta = phi - delta;
      else delta = 0.0;
    }
  at_turn_amount = (float)(GP_TURN_FACTOR) * f_not(f_near(delta,6.0)); 
  rhs_clear = occupied(300,-600,400,600,1);
  lhs_clear = occupied(300,600,400,600,1);

  ach = straight_down(MAX(ABS(x),ABS(y)),radius,(float)(radius * 0.5));
  left = up_straight(phi,10.0,30.0);
  right = up_straight(-phi,10.0,30.0);
  bleft = straight_down((float)lhs_clear,100.0,300.0);
  bright = straight_down((float)rhs_clear,100.0,300.0);
  wayoff = up_straight(ABS(phi),50.0,70.0);

  at_pos_on_left = f_and(left, f_or(wayoff,f_not(bleft)));
  at_pos_on_right = f_and(right, f_or(wayoff,f_not(bright)));
  at_pos_achieved = f_very(f_very(ach));
  at_angle_way_off = wayoff;
  
  at_too_slow = f_and(too_slow, f_and(f_not(ach), f_not(wayoff)));
  at_too_fast = f_and(too_fast, f_not(wayoff));

 /* Begin activity section */
   c_act_v = c_act_t = 0.0;
    c_act_v = 1.0;
    c_act_t = 1.0;
    c_progress = 1.0;
    c_goal = ach;
    ant__4 = f_or(at_too_slow,at_too_fast);
    ant__5 = at_pos_on_left;
    ant__6 = at_pos_on_right;
    ant__8 = at_pos_achieved;
    ant__10 = at_angle_way_off;
}


/* Ending code for behavior sfAnarAPos  */





//Ending Behavior/Act Schema Parser
